
// gcc -g BMediaFile-leak.cpp -lbe -lmedia -lroot_debug
// LD_PRELOAD=libroot_debug.so ./BMediaFile-leak

#include <stdio.h>
#include <media/MediaFile.h>
#include <storage/Entry.h>

#include <malloc_debug.h>


int main()
{
	entry_ref ref;
#error replace this with a path of your own before compiling
	get_ref_for_path( "/tmp/Apidya_Credits.mp3", &ref );
	
	heap_debug_dump_allocations( true, find_thread(NULL) );
	//total allocations: 416; total bytes: 77964

	// do ten times the new/delete cycle, to amplify
	// the leak and make it obvious:
	for( int i = 0; i < 10; i++ )
	{
		BMediaFile * mediaFile = new BMediaFile( &ref );
		heap_debug_dump_allocations( true, find_thread(NULL) );
		
		delete mediaFile;
		mediaFile = NULL;
		heap_debug_dump_allocations( true, find_thread(NULL) );
		
		//last of the 10 dumps shows 1MB leak:
		//total allocations: 4713; total bytes: 1233586
	}
//full list of allocations:
//heap_debug_dump_allocations( false, find_thread(NULL) );
// some 'pmff' markers at some allocations when inspecting memory:
//debugger( "0x180dd000" );
}

